2017-06-20 05:31:43 +08:00
#!/bin/bash
2017-06-21 04:17:41 +08:00
echo -en "Checking internet connection... "
timeout 1 bash -c "echo >/dev/tcp/8.8.8.8/53"
if [ [ $? != 0 ] ] ; then
echo -e "\e[31mfailed\e[0m"
exit 1
else
echo -e "\e[32mOK\e[0m"
fi
2017-06-21 05:05:43 +08:00
if [ [ -z $( which curl) ] ] ; then echo "Cannot find curl, exiting." ; exit 1; fi
if [ [ -z $( which docker-compose) ] ] ; then echo "Cannot find docker-compose, exiting." ; exit 1; fi
2017-06-21 05:22:39 +08:00
if [ [ -z $( which docker) ] ] ; then echo "Cannot find docker, exiting." ; exit 1; fi
2017-06-21 05:05:43 +08:00
if [ [ -z $( which git) ] ] ; then echo "Cannot find git, exiting." ; exit 1; fi
2017-06-21 05:41:25 +08:00
if [ [ -z $( which awk) ] ] ; then echo "Cannot find awk, exiting." ; exit 1; fi
if [ [ -z $( which sha1sum) ] ] ; then echo "Cannot find sha1sum, exiting." ; exit 1; fi
2017-06-20 05:31:43 +08:00
set -o pipefail
export LC_ALL = C
2017-06-20 06:02:03 +08:00
DATE = $( date +%Y-%m-%d_%H_%M_%S)
2017-06-20 05:31:43 +08:00
BRANCH = $( git rev-parse --abbrev-ref HEAD)
2017-06-21 05:41:25 +08:00
TMPFILE = $( mktemp " ${ TMPDIR :- /tmp } /curldata.XXXXXX " )
2017-06-21 17:46:01 +08:00
2017-06-21 17:48:03 +08:00
echo -e "\e[32mChecking for newer update script...\e[0m"
2017-06-21 22:44:57 +08:00
SHA1_1 = $( sha1sum update.sh)
git fetch origin ${ BRANCH }
git checkout origin/${ BRANCH } update.sh
SHA1_2 = $( sha1sum update.sh)
if [ [ ${ SHA1_1 } != ${ SHA1_2 } ] ] ; then
echo "update.sh changed, please run this script again, exiting."
chmod +x update.sh
2017-06-21 05:41:25 +08:00
exit 0
fi
2017-06-21 05:43:19 +08:00
rm -f mv ${ TMPFILE }
2017-06-21 04:17:41 +08:00
2017-06-21 03:40:15 +08:00
if [ [ -f mailcow.conf ] ] ; then
source mailcow.conf
else
echo -e "\e[31mNo mailcow.conf - is mailcow installed?\e[0m"
exit 1
fi
2017-06-20 05:31:43 +08:00
2017-06-21 18:10:20 +08:00
read -r -p "Are you sure you want to update mailcow: dockerized? All containers will be stopped. [y/N] " response
2017-06-21 05:05:43 +08:00
if [ [ ! " $response " = ~ ^( [ yY] [ eE] [ sS] | [ yY] ) +$ ] ] ; then
echo "OK, exiting."
exit 0
fi
echo -e "Stopping mailcow... "
2017-06-21 22:53:36 +08:00
sleep 2
2017-06-21 03:21:21 +08:00
docker-compose down
2017-06-20 05:31:43 +08:00
# Silently fixing remote url from andryyy to mailcow
git remote set-url origin https://github.com/mailcow/mailcow-dockerized
2017-06-21 17:48:03 +08:00
echo -e "\e[32mCommitting current status...\e[0m"
2017-06-20 05:31:43 +08:00
git add -u
git commit -am " Before update on ${ DATE } " > /dev/null
2017-06-21 17:48:03 +08:00
echo -e "\e[32mFetching updated code from remote...\e[0m"
2017-06-21 02:42:11 +08:00
git fetch origin ${ BRANCH }
2017-06-21 17:48:03 +08:00
echo -e "\e[32mMerging local with remote code (recursive, options: \"theirs\", \"patience\"...\e[0m"
2017-06-20 05:31:43 +08:00
git merge -Xtheirs -Xpatience -m " After update on ${ DATE } "
2017-06-21 17:57:32 +08:00
# Need to use a variable to not pass return codes of if checks
MERGE_RETURN = $?
if [ [ ${ MERGE_RETURN } = = 128 ] ] ; then
2017-06-21 22:44:57 +08:00
echo -e "\e[31m\nOh no, what happened?\n=> You most likely added files to your local mailcow instance that were now added to the official mailcow repository. Please move them to another location before updating mailcow.\e[0m"
exit 1
2017-06-21 17:57:32 +08:00
elif [ [ ${ MERGE_RETURN } = = 1 ] ] ; then
2017-06-21 22:44:57 +08:00
echo -e "\e[93mPotenial conflict, trying to fix...\e[0m"
git status --porcelain | grep -E "UD|DU" | awk '{print $2}' | xargs rm -v
git add -A
git commit -m " After update on ${ DATE } " > /dev/null
git checkout .
echo -e "\e[32mRemoved and recreated files if necessary.\e[0m"
2017-06-21 17:57:32 +08:00
elif [ [ ${ MERGE_RETURN } != 0 ] ] ; then
2017-06-21 22:44:57 +08:00
echo -e "\e[31m\nOh no, something went wrong. Please check the error message above.\e[0m"
echo
echo "Run docker-compose up -d to restart your stack without updates or try again after fixing the mentioned errors."
exit 1
2017-06-20 05:31:43 +08:00
fi
2017-06-21 17:46:01 +08:00
2017-06-21 03:21:21 +08:00
echo -e "\e[32mFetching new images, if any...\e[0m"
2017-06-21 22:53:36 +08:00
sleep 2
2017-06-21 03:21:21 +08:00
docker-compose pull
2017-06-21 05:22:39 +08:00
2017-06-21 03:40:15 +08:00
# Fix missing SSL, does not overwrite existing files
[ [ ! -d data/assets/ssl ] ] && mkdir -p data/assets/ssl
cp -n data/assets/ssl-example/*.pem data/assets/ssl/
2017-06-21 04:17:41 +08:00
2017-06-21 18:40:42 +08:00
echo -e "\e[32mFetching new docker-compose version...\e[0m"
2017-06-21 22:53:36 +08:00
sleep 2
2017-06-21 05:05:43 +08:00
curl -L https://github.com/docker/compose/releases/download/$( curl -Ls https://www.servercow.de/docker-compose/latest.php) /docker-compose-$( uname -s) -$( uname -m) > $( which docker-compose)
chmod +x $( which docker-compose)
2017-06-21 18:40:42 +08:00
echo -e "\e[32mStarting mailcow...\e[0m"
2017-06-21 22:53:36 +08:00
sleep 2
2017-06-21 05:22:39 +08:00
docker-compose up -d --remove-orphans
2017-06-21 18:10:20 +08:00
#echo -e "\e[32mCleaning up Docker objects...\e[0m"
2017-06-21 05:22:39 +08:00
if docker images -f "dangling=true" | grep ago --quiet; then
docker rmi -f $( docker images -f "dangling=true" -q)
docker volume rm $( docker volume ls -qf dangling = true )
fi
2017-06-21 18:10:20 +08:00
echo "In case you encounter any problem, hard-reset to a state before updating mailcow:"
echo
git reflog --color= always | grep "Before update on "
echo
echo "Use \"git reset --hard hash-on-the-left\" and run docker-compose up -d afterwards."